Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 1962)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 1973)
@@ -36,12 +36,10 @@
       , vAxisGroup_(), axisList_(), isAxisListSet(false)
       , vScalarGroup_(), scalarList_(), isScalarListSet(false)
-      , clientDistribution_(0), isIndexSent(false) , serverDistribution_(0), clientServerMap_(0)
-      , numberWrittenIndexes_(0), totalNumberWrittenIndexes_(0), offsetWrittenIndexes_(0)
+      , clientDistribution_(0), isIndexSent(false)
       , connectedDataSize_(), connectedServerRank_(), connectedServerRankRead_(), connectedDataSizeRead_()
 	    , isCompressible_(false)
       , transformations_(0), isTransformed_(false)
       , axisPositionInGrid_(), hasDomainAxisBaseRef_(false)
-      , gridSrc_(), hasTransform_(false), isGenerated_(false), order_(), globalIndexOnServer_()
-      , computedWrittenIndex_(false)
+      , gridSrc_(), hasTransform_(false), isGenerated_(false), order_()
       , clients()
    {
@@ -57,12 +55,10 @@
       , vAxisGroup_(), axisList_(), isAxisListSet(false)
       , vScalarGroup_(), scalarList_(), isScalarListSet(false)
-      , clientDistribution_(0), isIndexSent(false) , serverDistribution_(0), clientServerMap_(0)
-      , numberWrittenIndexes_(0), totalNumberWrittenIndexes_(0), offsetWrittenIndexes_(0)
+      , clientDistribution_(0), isIndexSent(false)
       , connectedDataSize_(), connectedServerRank_(), connectedServerRankRead_(), connectedDataSizeRead_()
 	    , isCompressible_(false)
       , transformations_(0), isTransformed_(false)
       , axisPositionInGrid_(), hasDomainAxisBaseRef_(false)
-      , gridSrc_(), hasTransform_(false), isGenerated_(false), order_(), globalIndexOnServer_()
-      , computedWrittenIndex_(false)
+      , gridSrc_(), hasTransform_(false), isGenerated_(false), order_()
       , clients()
    {
@@ -75,6 +71,4 @@
    {
     if (0 != clientDistribution_) delete clientDistribution_;
-    if (0 != serverDistribution_) delete serverDistribution_;
-    if (0 != clientServerMap_) delete clientServerMap_;
     if (0 != transformations_) delete transformations_;
    }
@@ -859,8 +853,4 @@
      this->checkAttributesAfterTransformation();
 
-     // TODO: Transfer grid attributes
-     //if (!context->hasClient && context->hasServer) this->createMask();
-     this->computeIndex();
-
      if (!(this->hasTransform() && !this->isTransformed()))
       this->isChecked = true;
@@ -897,180 +887,6 @@
       return mask_ ;
    }
-   /*
-     Create mask of grid from mask of its components
-   */
-   void CGrid::createMask(void)
-   TRY
-   {
-      using namespace std;
-      std::vector<CDomain*> domainP = this->getDomains();
-      std::vector<CAxis*> axisP = this->getAxis();
-      int dim = domainP.size() * 2 + axisP.size();
-
-      std::vector<CArray<bool,1>* > domainMasks(domainP.size());
-      for (int i = 0; i < domainMasks.size(); ++i) domainMasks[i] = &(domainP[i]->domainMask);
-      std::vector<CArray<bool,1>* > axisMasks(axisP.size());
-      for (int i = 0; i < axisMasks.size(); ++i) axisMasks[i] = &(axisP[i]->mask);
-
-      switch (dim) {
-        case 1:
-          checkGridMask(mask_1d, domainMasks, axisMasks, axis_domain_order, true);
-          break;
-        case 2:
-          checkGridMask(mask_2d, domainMasks, axisMasks, axis_domain_order, true);
-          break;
-        case 3:
-          checkGridMask(mask_3d, domainMasks, axisMasks, axis_domain_order, true);
-          break;
-        case 4:
-          checkGridMask(mask_4d, domainMasks, axisMasks, axis_domain_order, true);
-          break;
-        case 5:
-          checkGridMask(mask_5d, domainMasks, axisMasks, axis_domain_order, true);
-          break;
-        case 6:
-          checkGridMask(mask_6d, domainMasks, axisMasks, axis_domain_order, true);
-          break;
-        case 7:
-          checkGridMask(mask_7d, domainMasks, axisMasks, axis_domain_order, true);
-          break;
-        default:
-          break;
-      }
-   }
-   CATCH_DUMP_ATTR
-
-   /*
-     Check validity of grid's mask by using the masks of its components
-   */
-   void CGrid::checkMask(void)
-   TRY
-   {
-      using namespace std;
-      std::vector<CDomain*> domainP = this->getDomains();
-      std::vector<CAxis*> axisP = this->getAxis();
-      int dim = domainP.size() * 2 + axisP.size();
-
-      std::vector<CArray<bool,1>* > domainMasks(domainP.size());
-      for (int i = 0; i < domainMasks.size(); ++i) domainMasks[i] = &(domainP[i]->domainMask);
-      std::vector<CArray<bool,1>* > axisMasks(axisP.size());
-      for (int i = 0; i < axisMasks.size(); ++i) axisMasks[i] = &(axisP[i]->mask);
-
-      switch (dim) {
-        case 1:
-          checkGridMask(mask_1d, domainMasks, axisMasks, axis_domain_order);
-          break;
-        case 2:
-          checkGridMask(mask_2d, domainMasks, axisMasks, axis_domain_order);
-          break;
-        case 3:
-          checkGridMask(mask_3d, domainMasks, axisMasks, axis_domain_order);
-          break;
-        case 4:
-          checkGridMask(mask_4d, domainMasks, axisMasks, axis_domain_order);
-          break;
-        case 5:
-          checkGridMask(mask_5d, domainMasks, axisMasks, axis_domain_order);
-          break;
-        case 6:
-          checkGridMask(mask_6d, domainMasks, axisMasks, axis_domain_order);
-          break;
-        case 7:
-          checkGridMask(mask_7d, domainMasks, axisMasks, axis_domain_order);
-          break;
-        default:
-          break;
-      }
-   }
-   CATCH_DUMP_ATTR
-
-   /*
-     Modify value of mask in a certain index
-     This function can be used to correct the mask of grid after being constructed with createMask
-     \param [in] indexToModify
-     \param [in] modifyValue
-   */
-   void CGrid::modifyMask(const CArray<int,1>& indexToModify, bool modifyValue)
-   TRY
-   {
-      using namespace std;
-      std::vector<CDomain*> domainP = this->getDomains();
-      std::vector<CAxis*> axisP = this->getAxis();
-      int dim = domainP.size() * 2 + axisP.size();
-
-      switch (dim) {
-        case 0:
-          modifyGridMask(mask_0d, indexToModify, modifyValue);
-          break;
-        case 1:
-          modifyGridMask(mask_1d, indexToModify, modifyValue);
-          break;
-        case 2:
-          modifyGridMask(mask_2d, indexToModify, modifyValue);
-          break;
-        case 3:
-          modifyGridMask(mask_3d, indexToModify, modifyValue);
-          break;
-        case 4:
-          modifyGridMask(mask_4d, indexToModify, modifyValue);
-          break;
-        case 5:
-          modifyGridMask(mask_5d, indexToModify, modifyValue);
-          break;
-        case 6:
-          modifyGridMask(mask_6d, indexToModify, modifyValue);
-          break;
-        case 7:
-          modifyGridMask(mask_7d, indexToModify, modifyValue);
-          break;
-        default:
-          break;
-      }
-   }
-   CATCH_DUMP_ATTR
-
-   /*
-     Change the mask size. This function is used on reconstructing mask in server side
-     \param [in] newDimensionSize
-     \param [in] newValue 
-   */
-   void CGrid::modifyMaskSize(const std::vector<int>& newDimensionSize, bool newValue)
-   TRY
-   {      
-      std::vector<CDomain*> domainP = this->getDomains();
-      std::vector<CAxis*> axisP = this->getAxis();            
-      int dim = domainP.size() * 2 + axisP.size();
-
-      switch (dim) {
-        case 0:
-          modifyGridMaskSize(mask_0d, newDimensionSize, newValue);
-          break;
-        case 1:
-          modifyGridMaskSize(mask_1d, newDimensionSize, newValue);
-          break;
-        case 2:
-          modifyGridMaskSize(mask_2d, newDimensionSize, newValue);
-          break;
-        case 3:
-          modifyGridMaskSize(mask_3d, newDimensionSize, newValue);
-          break;
-        case 4:
-          modifyGridMaskSize(mask_4d, newDimensionSize, newValue);
-          break;
-        case 5:
-          modifyGridMaskSize(mask_5d, newDimensionSize, newValue);
-          break;
-        case 6:
-          modifyGridMaskSize(mask_6d, newDimensionSize, newValue);
-          break;
-        case 7:
-          modifyGridMaskSize(mask_7d, newDimensionSize, newValue);
-          break;
-        default:
-          break;
-      }
-   }
-   CATCH_DUMP_ATTR
-
+
+  
    //---------------------------------------------------------------
 
@@ -1130,94 +946,13 @@
    CATCH_DUMP_ATTR
 
-   /*!
-      Compute the index to for write data into a file
-   */
-   void CGrid::computeWrittenIndex()
-   TRY
-   {      
-      if (computedWrittenIndex_) return;
-      computedWrittenIndex_ = true;
-
-      if (isScalarGrid())
-      {
-        size_t nbWritten = 1;
-        int writtenIndex = 0;
-
-        localIndexToWriteOnClient_.resize(nbWritten);  
-        localIndexToWriteOnServer_.resize(nbWritten);
-        localIndexToWriteOnServer_(0) = writtenIndex;
-        localIndexToWriteOnClient_(0) = writtenIndex;
-        
-        return;
-      }
-
-      size_t nbWritten = 0, indGlo;
-      CDistributionClient::GlobalLocalDataMap& globalDataIndex = getClientDistribution()->getGlobalDataIndexOnClient();
-      CDistributionClient::GlobalLocalDataMap::const_iterator itb = globalDataIndex.begin(),
-                                                              ite = globalDataIndex.end(), it;    
-      const CDistributionServer::GlobalLocalMap& globalLocalIndex = serverDistribution_->getGlobalLocalIndex();                                                              
-      CDistributionServer::GlobalLocalMap::const_iterator itSrvb = globalLocalIndex.begin(),
-                                                          itSrve = globalLocalIndex.end(), itSrv;
-      for (it = itb; it != ite; ++it)
-      {
-        indGlo = it->first;
-        if (globalLocalIndex.end() != globalLocalIndex.find(indGlo)) ++nbWritten;                
-      }
-
-      localIndexToWriteOnClient_.resize(nbWritten);  
-      localIndexToWriteOnServer_.resize(nbWritten);
-      
-      {
-        numberWrittenIndexes_ = nbWritten;
-        if (isDataDistributed())
-        {
-          CContext* context = CContext::getCurrent();      
-          MPI_Allreduce(&numberWrittenIndexes_, &totalNumberWrittenIndexes_, 1, MPI_INT, MPI_SUM, context->intraComm_);
-          MPI_Scan(&numberWrittenIndexes_, &offsetWrittenIndexes_, 1, MPI_INT, MPI_SUM, context->intraComm_);
-          offsetWrittenIndexes_ -= numberWrittenIndexes_;
-        }
-        else
-          totalNumberWrittenIndexes_ = numberWrittenIndexes_;
-      }
-
-      nbWritten = 0; 
-      for (it = itb; it != ite; ++it)
-      {
-        indGlo = it->first;
-        itSrv = globalLocalIndex.find(indGlo);
-        if (itSrve != itSrv)
-        {
-          localIndexToWriteOnServer_(nbWritten) = itSrv->second;
-          localIndexToWriteOnClient_(nbWritten) = it->second;
-          ++nbWritten;                
-        } 
-      }
-   }
-   CATCH_DUMP_ATTR
-
-   
-
-   /*!
-     Compute the global index of grid to send to server as well as the connected server of the current client.
-     First of all, from the local data on each element of grid, we can calculate their local index which also allows us to know
-     their global index. We can have a map of global index of grid and local index that each client holds
-     Then, each client holds a piece of information about the distribution of servers, which permits to compute the connected server(s)
-     of the current client.
-   */
-   void CGrid::computeGridIndexToFileServer(CContextClient* client)
-   {
-     if (isScalarGrid()) computeConnectedClientsScalarGrid(client);
-     else computeConnectedClients(client);
-    
-     // compute indices for client/server transfer for domain
-     for (const auto& domainId : domList_) CDomain::get(domainId)->computeConnectedClients(client);
-   
-   
-     // compute indices for client/server transfer for axis
-     std::vector<CAxis*> axisList = this->getAxis();
-     for(int i=0 ; i<axisList.size(); i++) axisList[i] -> computeConnectedClients(client, getGlobalDimension(),getAxisPositionInGrid()[i]) ;
-   }
-   //---------------------------------------------------------------
-
+
+    //---------------------------------------------------------------
+   CDistributionClient* CGrid::getClientDistribution()
+   TRY
+   {
+     if (!computeClientDistribution_done_) computeClientDistribution() ;
+     return clientDistribution_;
+   }
+   CATCH_DUMP_ATTR
    
    void CGrid::computeClientDistribution(void)
@@ -1231,100 +966,4 @@
    }
 
-   void CGrid::computeStoreIndex_client(void)
-   {
-     if (computeStoreIndex_client_done_) return ;
-     else computeStoreIndex_client_done_ = true ;
-     if (isScalarGrid())
-     {
-       storeIndex_client_.resize(1);
-       storeIndex_client_(0) = 0;
-     }
-     else
-     {
-       CDistributionClient* clientDistribution = getClientDistribution() ;
-       const std::vector<int>& localDataIndex = clientDistribution->getLocalDataIndexOnClient() ;
-       int nbStoreIndex = localDataIndex.size() ;
-       storeIndex_client_.resize(nbStoreIndex);
-       for (int idx = 0; idx < nbStoreIndex; ++idx) storeIndex_client_(idx) = localDataIndex[idx];
-     }
-   }
-
-   void CGrid::computeStoreMask_client(void)
-   {
-     if (computeStoreMask_client_done_) return ;
-     else computeStoreMask_client_done_ = true ;
-     if (isScalarGrid())
-     {
-       storeMask_client_.resize(1);
-       storeMask_client_(0) = true;
-     }
-     else
-     {
-       CDistributionClient* clientDistribution = getClientDistribution() ;
-       const std::vector<bool>& localMaskIndex = clientDistribution->getLocalMaskIndexOnClient() ;
-       int nbMaskIndex = localMaskIndex.size() ;
-       storeMask_client_.resize(nbMaskIndex);
-       for (int idx = 0; idx < nbMaskIndex; ++idx) storeMask_client_(idx) = localMaskIndex[idx];
-     }
-   }
-
-
-  void CGrid::computeOutLocalIndexStoreOnClient(void)
-  {
-    if (computeOutLocalIndexStoreOnClient_done_) return ;
-    else computeOutLocalIndexStoreOnClient_done_=true ;
-
-    if (isScalarGrid())
-    {
-        auto& outGlobalIndexFromClient  = getOutGlobalIndexFromClient();
-        auto itb = outGlobalIndexFromClient.begin(), ite = outGlobalIndexFromClient.end() ;
-        for (auto it = itb; it != ite; ++it)
-        {
-          int rank = it->first;
-          CArray<size_t,1>& globalIndex = outGlobalIndexFromClient[rank];
-          outLocalIndexStoreOnClient_.insert(make_pair(rank, CArray<size_t,1>(globalIndex.numElements())));
-          CArray<size_t,1>& localIndex = outLocalIndexStoreOnClient_[rank];
-          if (1 != globalIndex.numElements())
-            ERROR("void CGrid::computeClientIndexScalarGrid()",
-              << "Something wrong happened. "
-              << "Number of received global index on scalar grid should equal to 1" 
-              << "Number of received global index " << globalIndex.numElements() << ".");
-
-          localIndex(0) = globalIndex(0);
-        }
-    }
-    else
-    {
-      CDistributionClient::GlobalLocalDataMap& globalDataIndex = getClientDistribution()->getGlobalDataIndexOnClient();
-      CDistributionClient::GlobalLocalDataMap::const_iterator itGloe = globalDataIndex.end();
-      auto& outGlobalIndexFromClient  = getOutGlobalIndexFromClient();
-      auto itb = outGlobalIndexFromClient.begin(), ite = outGlobalIndexFromClient.end() ;
-    
-      for (auto it = itb; it != ite; ++it)
-      {
-         int rank = it->first;
-         CArray<size_t,1>& globalIndex = outGlobalIndexFromClient[rank];
-         outLocalIndexStoreOnClient_.insert(make_pair(rank, CArray<size_t,1>(globalIndex.numElements())));
-         CArray<size_t,1>& localIndex = outLocalIndexStoreOnClient_[rank];
-         size_t nbIndex = 0;
-
-        // Keep this code for this moment but it should be removed (or moved to DEBUG) to improve performance
-        for (size_t idx = 0; idx < globalIndex.numElements(); ++idx)
-          if (itGloe != globalDataIndex.find(globalIndex(idx))) ++nbIndex;
-
-        if (nbIndex != localIndex.numElements())
-             ERROR("void CGrid::computeClientIndex()",
-                 << "Number of local index on client is different from number of received global index"
-                 << "Rank of sent client " << rank <<"."
-                 << "Number of local index " << nbIndex << ". "
-                 << "Number of received global index " << localIndex.numElements() << ".");
-
-        nbIndex = 0;
-        for (size_t idx = 0; idx < globalIndex.numElements(); ++idx)
-          if (itGloe != globalDataIndex.find(globalIndex(idx)))
-            localIndex(idx) = globalDataIndex[globalIndex(idx)];
-      }
-    }
-  }
 
   bool CGrid::isDataDistributed(void) 
@@ -1333,126 +972,5 @@
   }
 
-   /*!
-     Compute connected receivers and indexes to be sent to these receivers.
-   */
-   void CGrid::computeConnectedClients(CContextClient* client)
-   TRY
-   {
-     if (computeConnectedClients_done_.count(client)!=0) return ;
-     else  computeConnectedClients_done_.insert(client) ;
-
-     CContext* context = CContext::getCurrent();
-     
-     set<int> listReceiverSize ;
-     int receiverSize = client->serverSize;
-      
-     if (listReceiverSize.find(receiverSize)==listReceiverSize.end())
-     {
-       listReceiverSize.insert(receiverSize) ;
-       if (connectedServerRank_.find(receiverSize) != connectedServerRank_.end())
-       {
-          // delete corresponding map in case of recompute, probably because a grid could has been modifiedd 
-          // by a transformation
-          connectedServerRank_.erase(receiverSize);
-          connectedDataSize_.erase(receiverSize);
-          globalIndexOnServer_.erase(receiverSize);
-          nbSenders_.erase(receiverSize);
-       }
-
-       if (!doGridHaveDataDistributed(client))
-       {
-          if (client->isServerLeader())
-          {
-            size_t ssize = getClientDistribution()->getLocalDataIndexOnClient().size();
-            const std::list<int>& ranks = client->getRanksServerLeader();
-            for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-            {
-              connectedServerRank_[receiverSize].push_back(*itRank);
-              connectedDataSize_[receiverSize][*itRank] = ssize;
-            }
-          }
-          return;
-       }
-
-       // Compute mapping between client and server
-       std::vector<std::unordered_map<size_t,std::vector<int> > > indexServerOnElement;
-       CServerDistributionDescription serverDistributionDescription(getGlobalDimension(), client->serverSize);
-       std::vector<int> serverZeroIndex = serverDistributionDescription.computeServerGlobalByElement(indexServerOnElement,
-                                                                                                    client->clientRank,
-                                                                                                    client->clientSize,
-                                                                                                    axis_domain_order,
-                                                                                                    getDistributedDimension());
-
-       // Even if servers have no index, they must received something from client
-       // We only use several client to send "empty" message to these servers
-       std::list<int> serverZeroIndexLeader;
-       std::list<int> serverZeroIndexNotLeader;
-       CContextClient::computeLeader(client->clientRank, client->clientSize, serverZeroIndex.size(), serverZeroIndexLeader, serverZeroIndexNotLeader);
-       for (std::list<int>::iterator it = serverZeroIndexLeader.begin(); it != serverZeroIndexLeader.end(); ++it)
-         *it = serverZeroIndex[*it];
-
-       if (globalIndexOnServer_.find(receiverSize) == globalIndexOnServer_.end())
-         computeIndexByElement(indexServerOnElement, client, globalIndexOnServer_[receiverSize]);
-
-       const CDistributionClient::GlobalLocalDataMap& globalLocalIndexSendToServer = getClientDistribution()->getGlobalLocalDataSendToServer();
-       CDistributionClient::GlobalLocalDataMap::const_iterator iteGlobalLocalIndexMap = globalLocalIndexSendToServer.end(), itGlobalLocalIndexMap;
-       CClientServerMapping::GlobalIndexMap::const_iterator iteGlobalMap, itbGlobalMap, itGlobalMap;
-       itbGlobalMap = globalIndexOnServer_[receiverSize].begin();
-       iteGlobalMap = globalIndexOnServer_[receiverSize].end();
-
-       for (itGlobalMap  = itbGlobalMap; itGlobalMap != iteGlobalMap; ++itGlobalMap)
-       {
-         int serverRank = itGlobalMap->first;
-         int indexSize = itGlobalMap->second.size();
-         const std::vector<size_t>& indexVec = itGlobalMap->second;
-         for (int idx = 0; idx < indexSize; ++idx)
-         {
-            itGlobalLocalIndexMap = globalLocalIndexSendToServer.find(indexVec[idx]);
-            if (iteGlobalLocalIndexMap != itGlobalLocalIndexMap)
-            {
-              if (connectedDataSize_[receiverSize].end() == connectedDataSize_[receiverSize].find(serverRank))
-                connectedDataSize_[receiverSize][serverRank] = 1;
-              else
-                ++connectedDataSize_[receiverSize][serverRank];
-            }
-         }
-       }
-
-       // Connected servers which really have index
-       for (itGlobalMap = itbGlobalMap; itGlobalMap != iteGlobalMap; ++itGlobalMap) 
-         connectedServerRank_[receiverSize].push_back(itGlobalMap->first);
-     
-       // Connected servers which have no index at all
-       for (std::list<int>::iterator it = serverZeroIndexLeader.begin(); it != serverZeroIndexLeader.end(); ++it)
-         connectedServerRank_[receiverSize].push_back(*it);
-
-       // Even if a client has no index, it must connect to at least one server and
-       // send an "empty" data to this server
-       if (connectedServerRank_[receiverSize].empty())
-         connectedServerRank_[receiverSize].push_back(client->clientRank % client->serverSize);
- 
-       // Now check if all servers have data to receive. If not, master client will send empty data.
-       // This ensures that all servers will participate in collective calls upon receiving even if they have no date to receive.
-       std::vector<int> counts (client->clientSize);
-       std::vector<int> displs (client->clientSize);
-       displs[0] = 0;
-       int localCount = connectedServerRank_[receiverSize].size() ;
-       MPI_Gather(&localCount, 1, MPI_INT, &counts[0], 1, MPI_INT, 0, client->intraComm) ;
-       for (int i = 0; i < client->clientSize-1; ++i) displs[i+1] = displs[i] + counts[i];
-       std::vector<int> allConnectedServers(displs[client->clientSize-1]+counts[client->clientSize-1]);
-       MPI_Gatherv(&(connectedServerRank_[receiverSize])[0], localCount, MPI_INT, &allConnectedServers[0], &counts[0], &displs[0], MPI_INT, 0, client->intraComm);
-
-       if ((allConnectedServers.size() != receiverSize) && (client->clientRank == 0))
-       {
-         std::vector<bool> isSrvConnected (receiverSize, false);
-         for (int i = 0; i < allConnectedServers.size(); ++i) isSrvConnected[allConnectedServers[i]] = true;
-         for (int i = 0; i < receiverSize; ++i) if (!isSrvConnected[i]) connectedServerRank_[receiverSize].push_back(i);
-       }
-
-       nbSenders_[receiverSize] = CClientServerMapping::computeConnectedClients(receiverSize, client->clientSize, client->intraComm, connectedServerRank_[receiverSize]);
-     }
-   }
-   CATCH_DUMP_ATTR
-
+  
    /*!
      Compute the global index of grid to send to server as well as the connected server of the current client.
